

#include <systemc.h>
#include "Counter.h"
#include "Stimulus.h"
#include "Display.h"

int sc_main( int argc, char** argv ) {

    /*-	Signal Declaration	-*/
    sc_time	        SIM_TIME( 500, SC_NS );
    sc_clock        clk ("clk", sc_time(10,SC_NS) );
    sc_signal<int>	Value;
    sc_signal<bool>	Enable;
    sc_signal<bool>	UpDown;
    sc_signal<bool> Reset;

    /*-	Instantiation and Net Connection	-*/
    Counter iCounter( "iCounter" );
    iCounter.iclk( clk );

    Stimulus iStimulus( "iStimulus"	);
    iStimulus.iclk( clk );

    /*-	Run Simulation	-*/
    sc_start( SIM_TIME );

    /*-	Clean Up	-*/	
    return 0;

}



